#include<bits/stdc++.h>

using namespace std;

int n,k;
long long int arr[200005];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin>>n>>k;

    for (int i=0;i<n;i++)
    {
        cin>>arr[i];
    }

    if (k==0)
    {
        long long int sum=0;
        for (int i=0;i<n;i++)
        {
            sum=(sum+arr[i])%1000000007;
        }
        cout<<sum;
        return 0;
    }

    if (k==1)
    {
        long long int sum=0;
        for (int i=0;i<n;i++)
        {
            sum=(sum+(((i+1)*(n-i)*arr[i])%1000000007))%1000000007;
        }
        cout<<sum;
        return 0;
    }

    return 0;
}